<!DOCTYPE html>
<html>    
 <head> <!-- Entête HTML --> 
   <meta charset="utf-8" />
   <title>Calculateur</title>
 </head>
 <body>
 <?php
 define("WEB_EOL","<br>");
 // --- on récupère les données ---
 $saisie=$_POST['saisie'] ;
 $i=0;
 // initialisation des variables
 $nb=0      ;
 $chiffre=0 ;
 $somme=0   ;
 $signe='+' ;
 // --- on traite les données ---
  while ($i < strlen($saisie))
  {
    $caract=$saisie[$i++];
    switch($caract)
    {
      case '+' : case '-' :
            if ($signe == '+') $somme = $somme+$nb ;
            else               $somme = $somme-$nb ;
            $nb=0            ;
            $signe = $caract ;
            break;
      case '0':case '1':case '2':case '3':case '4':
      case '5':case '6':case '7':case '8':case '9':
            $chiffre = ord($caract)-48  ;
            $nb      = ($nb*10)+$chiffre;
            break;
    }
  }
  if ($signe == '+')  $somme = $somme+$nb ;
  else                $somme = $somme-$nb ;
  
  echo "R&eacute;sultat = ",$somme,WEB_EOL; 
 ?>
 </body>
</html>
